
/* Subroutine */ int de70dk_c(integer *k, doublereal *rabc, doublereal *alp,
	doublereal *alpn, doublereal *cmar, doublereal *p, doublereal *s)
{
    /* System generated locals */
    integer cmar_dim1, cmar_offset, i__1, i__2;

    /* Builtin functions */
    double cos(doublereal);

    /* Local variables */
    static integer i__, j;
    static doublereal r__, w, pi;
    static integer jm1, km1;
    static doublereal wc0;
    static integer ipn, ipns;

    /* Parameter adjustments */
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --alp;
    --rabc;
    --p;
    --s;

    /* Function Body */
    pi = 3.1415926535897932385;
/*     PI=3.14_159_265_358_979_323_85 */
/*       CONSTRUCTION OF PASCAL MATRIX */
    km1 = *k - 1;
    i__1 = km1;
    for (j = 1; j <= i__1; ++j) {
/* L10: */
	cmar[j + j * cmar_dim1] = 1.;
    }
    i__1 = *k;
    for (j = 2; j <= i__1; ++j) {
	cmar[j * cmar_dim1 + 1] = (doublereal) j;
	if (j == 2) {
	    goto L20;
	}
	jm1 = j - 1;
	i__2 = jm1;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    cmar[i__ + j * cmar_dim1] = cmar[i__ - 1 + jm1 * cmar_dim1] +
		    cmar[i__ + jm1 * cmar_dim1];
/* L15: */
	}
L20:
	;
    }
/*       DISPLACEMENT OF PASCAL MATRIX */
    s[1] = 1.;
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L25: */
	s[j + 1] = s[j] * 2.;
    }
    ipns = *k + 1;
    ipn = 0;
    i__1 = km1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	r__ = .5;
	i__2 = *k;
	for (j = i__; j <= i__2; ++j) {
	    ++ipn;
	    ++ipns;
	    p[ipn] = cmar[i__ + j * cmar_dim1];
	    r__ *= 2.;
	    s[ipns] = cmar[i__ + j * cmar_dim1] * r__;
/* L30: */
	}
/* L35: */
    }
/*       CALCULATE OF MARKOV COEFFICIENTS */
    wc0 = 1. / (doublereal) ((*k << 1) + 1);
    com70d_1.wc1 = pi * wc0;
    com70d_1.wc2 = wc0 * 2.;
    com70d_1.wc3 = wc0 * 4.;
    com70d_1.lasn = *k + 1 - *k % 2;
/*       COEFFICIENTS MARKOV FOR A1 */
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	w = (doublereal) ((j << 1) - 1) * com70d_1.wc1;
	alpn[j] = cos(w);
	alp[j] = (alpn[j] + 1.) * .5;
	cmar[j * cmar_dim1 + 1] = alpn[j];
/* L40: */
    }
/*       COEFFICIENTS MARKOV FOR A2,...,AK */
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	r__ = (doublereal) ((j << 1) - 1) * com70d_1.wc1;
	i__2 = *k;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    cmar[i__ + j * cmar_dim1] = cos((doublereal) i__ * r__);
/*       CMAR(I,J)=DE70DT(I,ALPN(J)) */
/* L50: */
	}
/* L55: */
    }
    i__1 = *k;
    for (j = 2; j <= i__1; ++j) {
	rabc[j] = 1. / (doublereal) (j * j - 1);
/* L60: */
    }
    return 0;
} /* de70dk_c */
